'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateEmailHostname = validateEmailHostname;

var _dns = require('dns');

var _dns2 = _interopRequireDefault(_dns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function validateEmailHostname(email) {
  if (!email) return Promise.resolve(false);
  if (typeof email !== 'string') return Promise.resolve(false);

  var hostname = email.split('@')[1];
  if (!hostname) return Promise.resolve(false);

  return dnsResolve(hostname, 'MX').then(function (okay) {
    if (okay) {
      return true;
    }
    return dnsResolve(hostname, 'A').then(function (okay) {
      return Boolean(okay);
    });
  });
}

function dnsResolve(hostname, rrtype) {
  return new Promise(function (resolve) {
    _dns2.default.resolve(hostname, rrtype, function (err, result) {
      resolve(err ? undefined : result);
    });
  });
}

exports.default = validateEmailHostname;